/***************************************
 * Program Module to Generate a Fringe *
 * Pattern when Given Two Phase Maps   *
 * And Three Amplitude Maps            *
 ***************************************
 * Written By: Matthew Demas           *
 * University of Connecticut           *
 ***************************************/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

int main()
{
   int n, m;  
   int dimx, dimy;  
   double A1[dimx][dimy], A2[dimx][dimy], A3[dimx][dimy];
   double phi1[dimx][dimy], phi2[dimx][dimy];
   

   /* Creates a Fringe Pattern Given Three Amplitudes and Two Phases */
   for(n=0; n<dimx-1; n++) 
      for(m=0; m<dimy-1; m++) 
         Int[n][m]=A1[n][m]*A1[n][m] + 2*A1[n][m]*A2[n][m]*cos(phi2[n][m])
                   + 2*A1[n][m]*A3[n][m]*cos(phi3[n][m])
                   + 2*A2[n][m]*A3[n][m]*cos(phi2[n][m]-phi3[n][m]); 
   return 0;
}
