#ifndef _util_salib_h_
#define _util_salib_h_

// die MAX-Funktion
float max(float, float);

//liefert groesste p : 2^p<=n
unsigned int log2(unsigned int n);

// TRUE <=> n ist Zweierpotenz
unsigned int ist2pot(unsigned int n);

/* sqrt(n) fuer den Sonderfall n=2^(2p) - notwendig fuer den 
	Fall der nicht-quadratischer logischen Partitionen*/
int wurzel(int n);

/*liefert p = 2^n fuer n>=0, sonst 0*/
int zwei_hoch(int n);

/* liefert a^b */
float potenz(float a, int b);

/* Wegen vollstaendig inkonsistenter Implementierung von % notwendig*/
unsigned int mod(int i,int m);

/*Gegeben Pfad liefert nur die Dateiname*/
const char * filename(const char *path);

// Gegeben Pfad liefert den Offset der Dateiname, d.h.
// *(path+offset) ist die Dateiname und
// strncpy(dest,path,offset) liefert nur den Pfad (ohne den Namen der Datei)
int filename_offset(const char *path);

// liefert eine Kopie von argv
//char ** CopyArgs(int argc , char **argv);

#endif
