// Klasse SA_Initializer : 
// Kommandozeile auswerten, Konfigurationsdatei lesen
// SA starten
// Autor : Peter Unruh

// HISTORY:
// - version 2.0
// -- REVISION 1 "PG BUGS"
//    Initial Solutions
//    sequential AartsScheduler
// --- Revision 1.0, Initial Solutions
//        Begin: 01.12.99    End: 01.12.99
// --- Revision 1.1, sequential AartsScheduler
// 		  Begin: 07.12.99	End: 16.12.99
// -- REVISION 2 "Consistent Version"
// 	  Get methods for BestSolution and State in Solver 
//	  bad return value of HC 
//    comments // \* change to // *
//    timelimit implementation in every Scheduler
//    SA.cfg templates
// --- Revision 2.0, BestSoltution and State
//  	  Begin: 16.12.99 	End: 16.12.99
// --- Revision 2.1, comments, retval HC, timelimit
//        Begin: 21.12.99 22.12.99
// -- REVISION 3, "Tactical Bugs"
//    WarmingUp without inittemp
//    Hillclimber break without solution output
//    SeqSolver in parallel version
//    Aarts does not freeze if accratio 0
//    GetLocalN and iterations does not match
//    vitual destructors in virtual classes recommended
// --- Revision 3.1, HC, virtual destructors, parallel SeqSolver, parallel logging,
//                   Init of subchainlength, Warming Up strategy of easy sched
//					 testchange in Aarts::Frozen(), output warminguptype
//        Begin: 05.01.00 End: 13.01.00
// -- REVSION 4, "LH Delivering Version"
//    SA.cfg rsc
// --- Revision 4.1 SA.cfg bugs
//        Begin: 18.01.99 18.01
// --- Revision 4.2 final version
// --- Revision 4.3 set solution filename
// -- REVISION 5 "Tested version"
//	  SA_Output for ClusteringSolver and SeqAartsScheduler, LINUX Bug
// --- Revision 5.1 LINUX Bug
//        Begin: 06.03.00 End: 01.04.00
// --- Revision 5.2 auf Clock Funktionen umgestellt

#define SRC_VERS_N "2.1"
#define SRC_REV_N "5.2"
#define SRC_REV_DATE "16.05.2000"
#define LAST_TASK "clock functions"

#ifndef _SA_Initializer_h_
#define _SA_Initializer_h_

#include "SA_Solver.h"

//---- SA_Initializer -----------------------------------------------------------

class SA_Initializer 
{
	char *	ConfigFileName;
public:
    SA_Initializer();
    ~SA_Initializer();

SA_Solver * ReadConfigFile(int argc, char ** argv, SA_Problem & probl);

};

#endif
