#ifndef SA_SeqSolver_H
#define SA_SeqSolver_H

//#include	<stdlib.h>
#include	<time.h>
#include	<string.h>


#include	"constants.h"
#include	"SA_SeqEasyScheduler.h"
#include    "SA_TimeScheduler.h"
#include 	"SA_Solver.h"
#include	"parrandom.h"		// Zufallszahlen
#include	"SA_Problem.h"
#include    "SA_Output.h"


// \******************************************************
// Klasse SA_SeqSolver :
//	Koordination von dem gesamten SA-Prozess 
// \****************************************************** 
class SA_SeqSolver : public SA_Solver
{ 
  protected:
//  SA_SeqEasyScheduler *Cooler;

  public:
  SA_SeqSolver(SA_Problem &);
  ~SA_SeqSolver();
  SA_Output *GetSolverOutput();

  int ReadConfig(std::istream &);				//read SeqSolver specific keywords from cfg file
  void ShowConfig();
  void	InitStates();
  int TestProblemImplementation();
  float SeqSimAnn(); 
  float RunAnnealing();
};

#endif
