#ifndef TINTKEYLIST_H
#define TINTKEYLIST_H

#define UNDEFINED -1;

//#include <iostream.h>
#include <iostream>
 
class TIntKeyListNode {
private:
  int key;
  TIntKeyListNode *next;
  void *data;
    
public:
  TIntKeyListNode();
  ~TIntKeyListNode();
  friend class TIntKeyList;  
  
  void Dump();
}; 

class TIntKeyList
{
private:
  TIntKeyListNode *head;
  TIntKeyListNode *curr;
  
public:
  TIntKeyList();
  ~TIntKeyList();

  void * Next();
  void * Get();
  void * Get(int);
  void Ins(int,void *);
  void Del();
  void Del(int);
  void Reset();
  int Empty();
  
  void Dump();
};

#endif
